package com.flyfish.framework.service;

import com.flyfish.framework.domain.UserQo;
import com.flyfish.framework.domain.base.Qo;
import com.flyfish.framework.domain.po.User;
import com.flyfish.framework.enums.UserStatus;
import com.flyfish.framework.enums.UserType;
import com.flyfish.framework.repository.UserRepository;
import com.flyfish.framework.service.impl.BaseServiceImpl;
import org.springframework.stereotype.Service;

import javax.annotation.PostConstruct;
import javax.annotation.Resource;
import java.util.List;
import java.util.Optional;

@Service
public class UserService extends BaseServiceImpl<User> {

    @Resource
    private DepartmentService departmentService;

    /**
     * 生成超级管理员
     */
    @PostConstruct
    private void init() {
        UserQo qo = new UserQo();
        qo.setUserType(UserType.SUPER_ADMIN.name());
        if (count(qo) == 0) {
            User user = new User();
            user.setUsername("admin");
            user.setPassword("admin");
            user.setUserType(UserType.SUPER_ADMIN);
            user.setEnable(true);
            user.setApp(false);
            user.setUserStatus(UserStatus.NORMAL);
            user.setPhone("10000000000");
            user.setName("超级管理员");
            user.setCode("Administrator");
            createSelective(user);
        }
    }

    /**
     * 获取用户数据
     *
     * @param username 用户
     * @return 结果
     */
    public Optional<User> findByUsername(String username) {
        return ((UserRepository) repository).findByUsername(username);
    }

    @Override
    public List<User> getList(Qo<User> query) {
        return super.getList(query);
    }
}
